Window.objectFocus = null;
Window.setObjectFocus = function(pObject) {
	if(pObject === Window.objectFocus) return true;
	
	var vOK = true;
	if((Window.objectFocus != null) && (Window.objectFocus.onblur)) vOK = Window.objectFocus.onblur();
	if(vOK) {
		Window.objectFocus = pObject;
		if((Window.objectFocus != null) && (Window.objectFocus.onfocus)) {
			Window.objectFocus.onfocus();
			if(Window.objectFocus.focus) { Window.objectFocus.focus(); }
			if(Window.objectFocus.select) { Window.objectFocus.select(0, -1); }
		}
	} else beep();
	if(Window.objectFocus.focus) Window.objectFocus.focus();
	
	return vOK;
}
TextArea.prototype.setFocus = function() { Window.setObjectFocus(this); }

/******** Tabbable Field *********/
function make_field_tabable(pField, pNextResponder, pPreviousResponder) {
	pField.nextResponder = pNextResponder;
	if(pPreviousResponder == null) pField.previousResponder = pField.nextResponder;
	else pField.previousResponder = pPreviousResponder;
	
	if(pField.constructor == TextArea) {
		var vFunctionCall = "if(system.event.keyString == \"Tab\") {\n";
		vFunctionCall += pField.name + ".rejectKeyPress();\n"
		vFunctionCall += "Window.setObjectFocus(" + pField.nextResponder.name + ");\n";
		//vFunctionCall += "} else if(system.event.keyString == \"Return\") {\n";
		//vFunctionCall += "if((" + pField.name + ".onblur) && (!" + pField.name + ".onblur())) beep();\n";
		//vFunctionCall += pField.name + ".rejectKeyPress();\n"
		vFunctionCall += "} else if(" + pField.name + ".onkeypress) {\n";
		vFunctionCall += pField.name + ".onkeypress();\n";
		vFunctionCall += "}";
		
		pField.onKeyPress = vFunctionCall;
	}
}

/******** Stepper control *********/
function make_stepper(pFieldObject, pStepperImage, pValueDictionary, pValueToIndexFunction, pTimer) {
	pFieldObject.stepper = pStepperImage;
	
	pStepperImage.values = pValueDictionary;
	pStepperImage.field = pFieldObject;
	pStepperImage.currentIndex = null;
	pStepperImage.valueMapping = pValueToIndexFunction;
	pStepperImage.mouseTracker = false;
	pStepperImage.mouseButtonTracker = false;
	pStepperImage.repeatTimer = pTimer;
	
	pFieldObject.setValue = function(pValue) {
		if(this.stepper != null) {
			this.data = pValue;
			this.stepper.setValue(pValue);
		}
	};
	
	pStepperImage.data = function() {
		return this.values[this.currentIndex];
	};
	pStepperImage.step = function(pX, pY) {
		if((this.field != null) && (this.values != null)) {
			var vNeighbors = [null, null, null];
			for(var vItem in this.values) {
				if(vNeighbors[1] != null) {
					vNeighbors[2] = vItem;
					break;
				}
				if(vItem == this.currentIndex) {
					vNeighbors[1] = vItem;
				}
				if(vNeighbors[1] == null) vNeighbors[0] = vItem;
			}
			if((pY - this.vOffset) < (this.height / 2)) {
				if(vNeighbors[2] == null) for(this.currentIndex in this.values) break;
				else this.currentIndex = vNeighbors[2];
			} else {
				if(vNeighbors[0] == null) {
					for(this.currentIndex in this.values) ;
				} else this.currentIndex = vNeighbors[0];
			}
			this.field.setValue(this.values[this.currentIndex]);
			if((this.mouseButtonTracker) && (pStepperImage.repeatTimer != null)) {
				pStepperImage.repeatTimer.onTimerFired = pStepperImage.name + ".step(system.event.hOffset, system.event.vOffset)";
				pStepperImage.repeatTimer.ticking = true;
				pStepperImage.repeatTimer.reset();
			}
		}
	};
	pStepperImage.setValue = function(pValue) {
		if((this.values != null) && (pStepperImage.valueMapping != null)) {
			var vIndex = pStepperImage.valueMapping(pValue, pStepperImage.values);
			if(vIndex != null) this.currentIndex = vIndex;
			else {
				print("Invalid value for " + this.name + ": " + pValue);
				alert("Invalid value: " + pValue);
				this.field.setValue(pStepperImage.data());
			}
		}
	};
	
	for(pStepperImage.currentIndex in pStepperImage.values) break;
	pFieldObject.setValue(pStepperImage.values[pStepperImage.currentIndex]);
	
	pStepperImage.onMouseEnter = pStepperImage.name + ".mouseTracker = true;";
	pStepperImage.onMouseExit = pStepperImage.name + ".mouseTracker = false;";
	var vFunctionCall = "if(" + pStepperImage.name + ".mouseTracker) {\n";
	vFunctionCall += pStepperImage.name + ".mouseButtonTracker = true;\n";
	vFunctionCall += "if(Window.setObjectFocus(" + pStepperImage.name + ")) {\n";
	vFunctionCall += pStepperImage.name + ".step(system.event.hOffset, system.event.vOffset);\n";
	vFunctionCall += "}\n";
	vFunctionCall += "}";
	pStepperImage.onMouseDown = vFunctionCall;
	pStepperImage.onMouseUp = pStepperImage.name + ".mouseButtonTracker = false; if(" + pStepperImage.name + ".repeatTimer != null) " + pStepperImage.name + ".repeatTimer.ticking = false; if(dateChange) dateChange(" + pStepperImage.name + ");";
}

/******** Search Field *********/
function make_searchfield(pField, pClear, pAction, pNextResponder, pPreviousResponder) {
	pField.action = pAction;
	pClear.field = pField;
	
	// Set-up the entry field:
	pField.onkeypress = function() {
		if(((system.event.keyString == "Return") || (system.event.keyString == "Enter")) && (this.action != null)) {
			this.action();
			this.rejectKeyPress();
		}
	};
	make_field_tabable(pField, pNextResponder, pPreviousResponder);
	
	// Set-up the "Clear" button:
	if(pClear != null) {
		pClear.mouseTracker = false;
		pClear.onMouseEnter = pClear.name + ".mouseTracker = true;";
		pClear.onMouseExit = pClear.name + ".mouseTracker = false;";
		pClear.onMouseUp = "if((" + pClear.name + ".mouseTracker) && (" + pClear.name + ".field != null)) " + pClear.name + ".field.data = \"\";";
	}
}
function add_to_recent_searches(pPrefObject, pValue) {
	if(pPrefObject != null) {
		pValue = pValue.replace(/[\r\n\f]/gm, "");
		
		// First, remove from the list
		var vRE = new RegExp(pValue + "\\+", "i");
		pPrefObject.value = pPrefObject.value.replace(vRE, "");
		
		// Then add in first position
		pPrefObject.value = pValue + "+" + pPrefObject.value;
		
		savePreferences();
	}
}
function load_recent_searches(pWindow, pPrefObject, pFieldName) {
	this.recentSearches = pPrefObject;
	
	if(this.recentSearches != null) {
		var vItems = new Array();
		var vLines = this.recentSearches.value.split("+");
		if((vLines == null) || (vLines[0] == "")) {
			vItems[0] = new MenuItem();
			vItems[0].title = "No Recent Searches";
			vItems[0].enabled = 0;
		} else {
			var vIndex = vItems.length;
			vItems[vIndex] = new MenuItem();
			vItems[vIndex].title = "Recent Searches";
			vItems[vIndex].enabled = 0;
			
			for(var vLoop = 0; vLoop < vLines.length; vLoop++) {
				if(vLines[vLoop] != "") {
					vIndex = vItems.length;
					vItems[vIndex] = new MenuItem();
					vItems[vIndex].title = vLines[vLoop];
					vItems[vIndex].onSelect = pFieldName + ".data = \"" + vLines[vLoop] + "\";";
				}
			}
			
			vIndex = vItems.length;
			vItems[vIndex] = new MenuItem();
			vItems[vIndex].title = "-";
			
			vIndex = vItems.length;
			vItems[vIndex] = new MenuItem();
			vItems[vIndex].title = "Clear Recent Searches";
			vItems[vIndex].onSelect = "clear_recent_searches();";
		}
		
		pWindow.contextMenuItems = vItems;
	}
}
function clear_recent_searches() {
	if(this.recentSearches != null) {
		this.recentSearches.value = "";
		savePreferences();
	}
}

/******** Progress Indicator *********/
function make_progress_indicator(element, imageBaseURL, timer) {
	timer.count = 0;
	timer.element = element;
	timer.element.opacity = "0";
	timer.imageBaseURL = imageBaseURL;
	
	timer.start = function () {
		this.element.opacity = "255";
		updateNow();
		this.ticking = false;
		this.onTimerFired = this.name + ".element.src = " + this.name + ".imageBaseURL + (" + this.name + ".count + 1) + \".png\"; " + this.name + ".count = (" + this.name + ".count + 1) % 12;";
		this.interval = 0.075;
		this.ticking = true;
	};
	timer.stop = function () {
		this.ticking = false
		this.element.opacity = "0";
		updateNow();
	}
}
