// **************** PUBLIC API ****************
function konfab_vcheck_textdb(pUpdateDatabaseURL, pWidgetIdentifier, pDBLineFormat) { konfab_vcheck_getDB(pUpdateDatabaseURL, konfab_vcheck_receive_textdb, { widgetID: pWidgetIdentifier, format: pDBLineFormat }); }


// **************** PRIVATE API ****************
function konfab_vcheck_receive_textdb(pUpdateDatabaseURL, pResponseText, pUserInfos) {
	if((pResponseText == null) || (pUserInfos == null)) return;
	
	try {
		var vLines = pResponseText.match(/^.*$/gm);
		
		var vRegEx = new RegExp(pUserInfos.format.replace(/id/gi, pUserInfos.widgetID).replace(/version/gi, "(\\d+(?:\\.\\d+)+)"), "i");
		var vDBVersion = null;
		for(var vLoop = 0; vLoop < vLines.length; vLoop++) {
			var vInfos = vLines[vLoop].match(vRegEx);
			if(vInfos != null) {
				vDBVersion = vInfos[1];
				break;
			}
		}
	} catch(vException) { return null; }
	
	konfab_vcheck(pUpdateDatabaseURL, vDBVersion, pUserInfos);
}
function konfab_vcheck(pUpdateDatabaseURL, pDBVersion, pUserInfos) {
	if((pDBVersion == null) || (pUserInfos == null)) return;
	
	var vTokens = filesystem.readFile(pUserInfos.widgetID + ".kon").match(/<widget.*?\s+?version="([\d\.]+)".*?>/mi);
	var vWidgetVersion = (vTokens == null) ? "" : vTokens[1];
	if(vWidgetVersion < pDBVersion) {
		if(alert("A new version of this widget is available. Would you like to upgrade now?", "Yes", "No, later") == 1)
			openURL("http://www.widgetizer.com");
	}
}

function konfab_vcheck_getDB(pUpdateDatabaseURL, pResponseHandler, pUserInfos) {
	if(pUpdateDatabaseURL == null) return null;
	
	// get db file, return string content
	var vURL = new URL();
	vURL.fetch(pUpdateDatabaseURL);
	
	if(parseInt(vURL.response) != 200) return;
	
	if(pResponseHandler != null) pResponseHandler(pUpdateDatabaseURL, vURL.responseData, pUserInfos);
}
